#include "stop_words_list.h"
namespace mongo {
namespace fts {

  void loadStopWordMap( StringMap< std::set< std::string > >* m ) {

  // src/mongo/db/fts/stop_words_danish.txt
  {
   const char* const words[] = {
       "ad",
       "af",
       "alle",
       "alt",
       "anden",
       "at",
       "blev",
       "blive",
       "bliver",
       "da",
       "de",
       "dem",
       "den",
       "denne",
       "der",
       "deres",
       "det",
       "dette",
       "dig",
       "din",
       "disse",
       "dog",
       "du",
       "efter",
       "eller",
       "en",
       "end",
       "er",
       "et",
       "for",
       "fra",
       "ham",
       "han",
       "hans",
       "har",
       "havde",
       "have",
       "hende",
       "hendes",
       "her",
       "hos",
       "hun",
       "hvad",
       "hvis",
       "hvor",
       "i",
       "ikke",
       "ind",
       "jeg",
       "jer",
       "jo",
       "kunne",
       "man",
       "mange",
       "med",
       "meget",
       "men",
       "mig",
       "min",
       "mine",
       "mit",
       "mod",
       "ned",
       "noget",
       "nogle",
       "nu",
       "når",
       "og",
       "også",
       "om",
       "op",
       "os",
       "over",
       "på",
       "selv",
       "sig",
       "sin",
       "sine",
       "sit",
       "skal",
       "skulle",
       "som",
       "sådan",
       "thi",
       "til",
       "ud",
       "under",
       "var",
       "vi",
       "vil",
       "ville",
       "vor",
       "være",
       "været",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["danish"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_dutch.txt
  {
   const char* const words[] = {
       "aan",
       "al",
       "alles",
       "als",
       "altijd",
       "andere",
       "ben",
       "bij",
       "daar",
       "dan",
       "dat",
       "de",
       "der",
       "deze",
       "die",
       "dit",
       "doch",
       "doen",
       "door",
       "dus",
       "een",
       "eens",
       "en",
       "er",
       "ge",
       "geen",
       "geweest",
       "haar",
       "had",
       "heb",
       "hebben",
       "heeft",
       "hem",
       "het",
       "hier",
       "hij",
       "hoe",
       "hun",
       "iemand",
       "iets",
       "ik",
       "in",
       "is",
       "ja",
       "je",
       "kan",
       "kon",
       "kunnen",
       "maar",
       "me",
       "meer",
       "men",
       "met",
       "mij",
       "mijn",
       "moet",
       "na",
       "naar",
       "niet",
       "niets",
       "nog",
       "nu",
       "of",
       "om",
       "omdat",
       "onder",
       "ons",
       "ook",
       "op",
       "over",
       "reeds",
       "te",
       "tegen",
       "toch",
       "toen",
       "tot",
       "u",
       "uit",
       "uw",
       "van",
       "veel",
       "voor",
       "want",
       "waren",
       "was",
       "wat",
       "werd",
       "wezen",
       "wie",
       "wil",
       "worden",
       "wordt",
       "zal",
       "ze",
       "zelf",
       "zich",
       "zij",
       "zijn",
       "zo",
       "zonder",
       "zou",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["dutch"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_english.txt
  {
   const char* const words[] = {
       "a",
       "about",
       "above",
       "after",
       "again",
       "against",
       "all",
       "am",
       "an",
       "and",
       "any",
       "are",
       "aren't",
       "as",
       "at",
       "be",
       "because",
       "been",
       "before",
       "being",
       "below",
       "between",
       "both",
       "but",
       "by",
       "can't",
       "cannot",
       "could",
       "couldn't",
       "did",
       "didn't",
       "do",
       "does",
       "doesn't",
       "doing",
       "don't",
       "down",
       "during",
       "each",
       "few",
       "for",
       "from",
       "further",
       "had",
       "hadn't",
       "has",
       "hasn't",
       "have",
       "haven't",
       "having",
       "he",
       "he'd",
       "he'll",
       "he's",
       "her",
       "here",
       "here's",
       "hers",
       "herself",
       "him",
       "himself",
       "his",
       "how",
       "how's",
       "i",
       "i'd",
       "i'll",
       "i'm",
       "i've",
       "if",
       "in",
       "into",
       "is",
       "isn't",
       "it",
       "it's",
       "its",
       "itself",
       "let's",
       "me",
       "more",
       "most",
       "mustn't",
       "my",
       "myself",
       "no",
       "nor",
       "not",
       "of",
       "off",
       "on",
       "once",
       "only",
       "or",
       "other",
       "ought",
       "our",
       "ours",
       "ourselves",
       "out",
       "over",
       "own",
       "same",
       "shan't",
       "she",
       "she'd",
       "she'll",
       "she's",
       "should",
       "shouldn't",
       "so",
       "some",
       "such",
       "than",
       "that",
       "that's",
       "the",
       "their",
       "theirs",
       "them",
       "themselves",
       "then",
       "there",
       "there's",
       "these",
       "they",
       "they'd",
       "they'll",
       "they're",
       "they've",
       "this",
       "those",
       "through",
       "to",
       "too",
       "under",
       "until",
       "up",
       "very",
       "was",
       "wasn't",
       "we",
       "we'd",
       "we'll",
       "we're",
       "we've",
       "were",
       "weren't",
       "what",
       "what's",
       "when",
       "when's",
       "where",
       "where's",
       "which",
       "while",
       "who",
       "who's",
       "whom",
       "why",
       "why's",
       "with",
       "won't",
       "would",
       "wouldn't",
       "you",
       "you'd",
       "you'll",
       "you're",
       "you've",
       "your",
       "yours",
       "yourself",
       "yourselves",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["english"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_finnish.txt
  {
   const char* const words[] = {
       "ei",
       "eivät",
       "emme",
       "en",
       "et",
       "ette",
       "että",
       "he",
       "heidän",
       "heidät",
       "heihin",
       "heille",
       "heillä",
       "heiltä",
       "heissä",
       "heistä",
       "heitä",
       "hän",
       "häneen",
       "hänelle",
       "hänellä",
       "häneltä",
       "hänen",
       "hänessä",
       "hänestä",
       "hänet",
       "häntä",
       "itse",
       "ja",
       "johon",
       "joiden",
       "joihin",
       "joiksi",
       "joilla",
       "joille",
       "joilta",
       "joina",
       "joissa",
       "joista",
       "joita",
       "joka",
       "joksi",
       "jolla",
       "jolle",
       "jolta",
       "jona",
       "jonka",
       "jos",
       "jossa",
       "josta",
       "jota",
       "jotka",
       "kanssa",
       "keiden",
       "keihin",
       "keiksi",
       "keille",
       "keillä",
       "keiltä",
       "keinä",
       "keissä",
       "keistä",
       "keitä",
       "keneen",
       "keneksi",
       "kenelle",
       "kenellä",
       "keneltä",
       "kenen",
       "kenenä",
       "kenessä",
       "kenestä",
       "kenet",
       "ketkä",
       "ketkä",
       "ketä",
       "koska",
       "kuin",
       "kuka",
       "kun",
       "me",
       "meidän",
       "meidät",
       "meihin",
       "meille",
       "meillä",
       "meiltä",
       "meissä",
       "meistä",
       "meitä",
       "mihin",
       "miksi",
       "mikä",
       "mille",
       "millä",
       "miltä",
       "minkä",
       "minkä",
       "minua",
       "minulla",
       "minulle",
       "minulta",
       "minun",
       "minussa",
       "minusta",
       "minut",
       "minuun",
       "minä",
       "minä",
       "missä",
       "mistä",
       "mitkä",
       "mitä",
       "mukaan",
       "mutta",
       "ne",
       "niiden",
       "niihin",
       "niiksi",
       "niille",
       "niillä",
       "niiltä",
       "niin",
       "niin",
       "niinä",
       "niissä",
       "niistä",
       "niitä",
       "noiden",
       "noihin",
       "noiksi",
       "noilla",
       "noille",
       "noilta",
       "noin",
       "noina",
       "noissa",
       "noista",
       "noita",
       "nuo",
       "nyt",
       "näiden",
       "näihin",
       "näiksi",
       "näille",
       "näillä",
       "näiltä",
       "näinä",
       "näissä",
       "näistä",
       "näitä",
       "nämä",
       "ole",
       "olemme",
       "olen",
       "olet",
       "olette",
       "oli",
       "olimme",
       "olin",
       "olisi",
       "olisimme",
       "olisin",
       "olisit",
       "olisitte",
       "olisivat",
       "olit",
       "olitte",
       "olivat",
       "olla",
       "olleet",
       "ollut",
       "on",
       "ovat",
       "poikki",
       "se",
       "sekä",
       "sen",
       "siihen",
       "siinä",
       "siitä",
       "siksi",
       "sille",
       "sillä",
       "sillä",
       "siltä",
       "sinua",
       "sinulla",
       "sinulle",
       "sinulta",
       "sinun",
       "sinussa",
       "sinusta",
       "sinut",
       "sinuun",
       "sinä",
       "sinä",
       "sitä",
       "tai",
       "te",
       "teidän",
       "teidät",
       "teihin",
       "teille",
       "teillä",
       "teiltä",
       "teissä",
       "teistä",
       "teitä",
       "tuo",
       "tuohon",
       "tuoksi",
       "tuolla",
       "tuolle",
       "tuolta",
       "tuon",
       "tuona",
       "tuossa",
       "tuosta",
       "tuota",
       "tähän",
       "täksi",
       "tälle",
       "tällä",
       "tältä",
       "tämä",
       "tämän",
       "tänä",
       "tässä",
       "tästä",
       "tätä",
       "vaan",
       "vai",
       "vaikka",
       "yli",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["finnish"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_french.txt
  {
   const char* const words[] = {
       "a",
       "ai",
       "aie",
       "aient",
       "aies",
       "ait",
       "alors",
       "as",
       "au",
       "aucun",
       "aura",
       "aurai",
       "auraient",
       "aurais",
       "aurait",
       "auras",
       "aurez",
       "auriez",
       "aurions",
       "aurons",
       "auront",
       "aussi",
       "autre",
       "aux",
       "avaient",
       "avais",
       "avait",
       "avant",
       "avec",
       "avez",
       "aviez",
       "avions",
       "avoir",
       "avons",
       "ayant",
       "ayez",
       "ayons",
       "bon",
       "car",
       "ce",
       "ceci",
       "cela",
       "ces",
       "cet",
       "cette",
       "ceux",
       "chaque",
       "ci",
       "comme",
       "comment",
       "d",
       "dans",
       "de",
       "dedans",
       "dehors",
       "depuis",
       "des",
       "deux",
       "devoir",
       "devrait",
       "devrez",
       "devriez",
       "devrions",
       "devrons",
       "devront",
       "dois",
       "doit",
       "donc",
       "dos",
       "droite",
       "du",
       "dès",
       "début",
       "dù",
       "elle",
       "elles",
       "en",
       "encore",
       "es",
       "est",
       "et",
       "eu",
       "eue",
       "eues",
       "eurent",
       "eus",
       "eusse",
       "eussent",
       "eusses",
       "eussiez",
       "eussions",
       "eut",
       "eux",
       "eûmes",
       "eût",
       "eûtes",
       "faire",
       "fais",
       "faisez",
       "fait",
       "faites",
       "fois",
       "font",
       "force",
       "furent",
       "fus",
       "fusse",
       "fussent",
       "fusses",
       "fussiez",
       "fussions",
       "fut",
       "fûmes",
       "fût",
       "fûtes",
       "haut",
       "hors",
       "ici",
       "il",
       "ils",
       "j",
       "je",
       "juste",
       "l",
       "la",
       "le",
       "les",
       "leur",
       "leurs",
       "lui",
       "là",
       "m",
       "ma",
       "maintenant",
       "mais",
       "me",
       "mes",
       "moi",
       "moins",
       "mon",
       "mot",
       "même",
       "n",
       "ne",
       "ni",
       "nom",
       "nommé",
       "nommée",
       "nommés",
       "nos",
       "notre",
       "nous",
       "nouveau",
       "nouveaux",
       "on",
       "ont",
       "ou",
       "où",
       "par",
       "parce",
       "parole",
       "pas",
       "personne",
       "personnes",
       "peu",
       "peut",
       "plupart",
       "pour",
       "pourquoi",
       "qu",
       "quand",
       "que",
       "quel",
       "quelle",
       "quelles",
       "quels",
       "qui",
       "sa",
       "sans",
       "se",
       "sera",
       "serai",
       "seraient",
       "serais",
       "serait",
       "seras",
       "serez",
       "seriez",
       "serions",
       "serons",
       "seront",
       "ses",
       "seulement",
       "si",
       "sien",
       "soi",
       "soient",
       "sois",
       "soit",
       "sommes",
       "son",
       "sont",
       "sous",
       "soyez",
       "soyons",
       "suis",
       "sujet",
       "sur",
       "t",
       "ta",
       "tandis",
       "te",
       "tellement",
       "tels",
       "tes",
       "toi",
       "ton",
       "tous",
       "tout",
       "trop",
       "très",
       "tu",
       "un",
       "une",
       "valeur",
       "voient",
       "vois",
       "voit",
       "vont",
       "vos",
       "votre",
       "vous",
       "vu",
       "y",
       "à",
       "ça",
       "étaient",
       "étais",
       "était",
       "étant",
       "état",
       "étiez",
       "étions",
       "été",
       "étés",
       "êtes",
       "être",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["french"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_german.txt
  {
   const char* const words[] = {
       "aber",
       "alle",
       "allem",
       "allen",
       "aller",
       "alles",
       "als",
       "also",
       "am",
       "an",
       "ander",
       "andere",
       "anderem",
       "anderen",
       "anderer",
       "anderes",
       "anderm",
       "andern",
       "anders",
       "auch",
       "auf",
       "aus",
       "bei",
       "bin",
       "bis",
       "bist",
       "da",
       "damit",
       "dann",
       "das",
       "dass",
       "dasselbe",
       "dazu",
       "daß",
       "dein",
       "deine",
       "deinem",
       "deinen",
       "deiner",
       "deines",
       "dem",
       "demselben",
       "den",
       "denn",
       "denselben",
       "der",
       "derer",
       "derselbe",
       "derselben",
       "des",
       "desselben",
       "dessen",
       "dich",
       "die",
       "dies",
       "diese",
       "dieselbe",
       "dieselben",
       "diesem",
       "diesen",
       "dieser",
       "dieses",
       "dir",
       "doch",
       "dort",
       "du",
       "durch",
       "ein",
       "eine",
       "einem",
       "einen",
       "einer",
       "eines",
       "einig",
       "einige",
       "einigem",
       "einigen",
       "einiger",
       "einiges",
       "einmal",
       "er",
       "es",
       "etwas",
       "euch",
       "euer",
       "eure",
       "eurem",
       "euren",
       "eurer",
       "eures",
       "für",
       "gegen",
       "gewesen",
       "hab",
       "habe",
       "haben",
       "hat",
       "hatte",
       "hatten",
       "hier",
       "hin",
       "hinter",
       "ich",
       "ihm",
       "ihn",
       "ihnen",
       "ihr",
       "ihre",
       "ihrem",
       "ihren",
       "ihrer",
       "ihres",
       "im",
       "in",
       "indem",
       "ins",
       "ist",
       "jede",
       "jedem",
       "jeden",
       "jeder",
       "jedes",
       "jene",
       "jenem",
       "jenen",
       "jener",
       "jenes",
       "jetzt",
       "kann",
       "kein",
       "keine",
       "keinem",
       "keinen",
       "keiner",
       "keines",
       "können",
       "könnte",
       "machen",
       "man",
       "manche",
       "manchem",
       "manchen",
       "mancher",
       "manches",
       "mein",
       "meine",
       "meinem",
       "meinen",
       "meiner",
       "meines",
       "mich",
       "mir",
       "mit",
       "muss",
       "musste",
       "nach",
       "nicht",
       "nichts",
       "noch",
       "nun",
       "nur",
       "ob",
       "oder",
       "ohne",
       "sehr",
       "sein",
       "seine",
       "seinem",
       "seinen",
       "seiner",
       "seines",
       "selbst",
       "sich",
       "sie",
       "sind",
       "so",
       "solche",
       "solchem",
       "solchen",
       "solcher",
       "solches",
       "soll",
       "sollte",
       "sondern",
       "sonst",
       "um",
       "und",
       "uns",
       "unse",
       "unsem",
       "unsen",
       "unser",
       "unses",
       "unter",
       "viel",
       "vom",
       "von",
       "vor",
       "war",
       "waren",
       "warst",
       "was",
       "weg",
       "weil",
       "weiter",
       "welche",
       "welchem",
       "welchen",
       "welcher",
       "welches",
       "wenn",
       "werde",
       "werden",
       "wie",
       "wieder",
       "will",
       "wir",
       "wird",
       "wirst",
       "wo",
       "wollen",
       "wollte",
       "während",
       "würde",
       "würden",
       "zu",
       "zum",
       "zur",
       "zwar",
       "zwischen",
       "über",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["german"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_hungarian.txt
  {
   const char* const words[] = {
       "a",
       "abban",
       "ahhoz",
       "ahogy",
       "ahol",
       "aki",
       "akik",
       "akkor",
       "alatt",
       "amely",
       "amelyek",
       "amelyekben",
       "amelyeket",
       "amelyet",
       "amelynek",
       "ami",
       "amikor",
       "amit",
       "amolyan",
       "amíg",
       "annak",
       "arra",
       "arról",
       "az",
       "azok",
       "azon",
       "azonban",
       "azt",
       "aztán",
       "azután",
       "azzal",
       "azért",
       "be",
       "belül",
       "benne",
       "bár",
       "cikk",
       "cikkek",
       "cikkeket",
       "csak",
       "de",
       "e",
       "ebben",
       "eddig",
       "egy",
       "egyes",
       "egyetlen",
       "egyik",
       "egyre",
       "egyéb",
       "egész",
       "ehhez",
       "ekkor",
       "el",
       "ellen",
       "elsõ",
       "elég",
       "elõ",
       "elõször",
       "elõtt",
       "emilyen",
       "ennek",
       "erre",
       "ez",
       "ezek",
       "ezen",
       "ezt",
       "ezzel",
       "ezért",
       "fel",
       "felé",
       "hanem",
       "hiszen",
       "hogy",
       "hogyan",
       "igen",
       "ill",
       "ill.",
       "illetve",
       "ilyen",
       "ilyenkor",
       "ismét",
       "ison",
       "itt",
       "jobban",
       "jó",
       "jól",
       "kell",
       "kellett",
       "keressünk",
       "keresztül",
       "ki",
       "kívül",
       "között",
       "közül",
       "legalább",
       "legyen",
       "lehet",
       "lehetett",
       "lenne",
       "lenni",
       "lesz",
       "lett",
       "maga",
       "magát",
       "majd",
       "majd",
       "meg",
       "mellett",
       "mely",
       "melyek",
       "mert",
       "mi",
       "mikor",
       "milyen",
       "minden",
       "mindenki",
       "mindent",
       "mindig",
       "mint",
       "mintha",
       "mit",
       "mivel",
       "miért",
       "most",
       "már",
       "más",
       "másik",
       "még",
       "míg",
       "nagy",
       "nagyobb",
       "nagyon",
       "ne",
       "nekem",
       "neki",
       "nem",
       "nincs",
       "néha",
       "néhány",
       "nélkül",
       "olyan",
       "ott",
       "pedig",
       "persze",
       "rá",
       "s",
       "saját",
       "sem",
       "semmi",
       "sok",
       "sokat",
       "sokkal",
       "szemben",
       "szerint",
       "szinte",
       "számára",
       "talán",
       "tehát",
       "teljes",
       "tovább",
       "továbbá",
       "több",
       "ugyanis",
       "utolsó",
       "után",
       "utána",
       "vagy",
       "vagyis",
       "vagyok",
       "valaki",
       "valami",
       "valamint",
       "való",
       "van",
       "vannak",
       "vele",
       "vissza",
       "viszont",
       "volna",
       "volt",
       "voltak",
       "voltam",
       "voltunk",
       "által",
       "általában",
       "át",
       "én",
       "éppen",
       "és",
       "így",
       "õ",
       "õk",
       "õket",
       "össze",
       "úgy",
       "új",
       "újabb",
       "újra",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["hungarian"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_italian.txt
  {
   const char* const words[] = {
       "a",
       "abbia",
       "abbiamo",
       "abbiano",
       "abbiate",
       "ad",
       "adesso",
       "agl",
       "agli",
       "ai",
       "al",
       "all",
       "alla",
       "alle",
       "allo",
       "allora",
       "altre",
       "altri",
       "altro",
       "anche",
       "ancora",
       "avemmo",
       "avendo",
       "avere",
       "avesse",
       "avessero",
       "avessi",
       "avessimo",
       "aveste",
       "avesti",
       "avete",
       "aveva",
       "avevamo",
       "avevano",
       "avevate",
       "avevi",
       "avevo",
       "avrai",
       "avranno",
       "avrebbe",
       "avrebbero",
       "avrei",
       "avremmo",
       "avremo",
       "avreste",
       "avresti",
       "avrete",
       "avrà",
       "avrò",
       "avuta",
       "avute",
       "avuti",
       "avuto",
       "c",
       "che",
       "chi",
       "ci",
       "coi",
       "col",
       "come",
       "con",
       "contro",
       "cui",
       "da",
       "dagl",
       "dagli",
       "dai",
       "dal",
       "dall",
       "dalla",
       "dalle",
       "dallo",
       "degl",
       "degli",
       "dei",
       "del",
       "dell",
       "della",
       "delle",
       "dello",
       "dentro",
       "di",
       "dov",
       "dove",
       "e",
       "ebbe",
       "ebbero",
       "ebbi",
       "ecco",
       "ed",
       "era",
       "erano",
       "eravamo",
       "eravate",
       "eri",
       "ero",
       "essendo",
       "faccia",
       "facciamo",
       "facciano",
       "facciate",
       "faccio",
       "facemmo",
       "facendo",
       "facesse",
       "facessero",
       "facessi",
       "facessimo",
       "faceste",
       "facesti",
       "faceva",
       "facevamo",
       "facevano",
       "facevate",
       "facevi",
       "facevo",
       "fai",
       "fanno",
       "farai",
       "faranno",
       "fare",
       "farebbe",
       "farebbero",
       "farei",
       "faremmo",
       "faremo",
       "fareste",
       "faresti",
       "farete",
       "farà",
       "farò",
       "fece",
       "fecero",
       "feci",
       "fino",
       "fosse",
       "fossero",
       "fossi",
       "fossimo",
       "foste",
       "fosti",
       "fra",
       "fu",
       "fui",
       "fummo",
       "furono",
       "giù",
       "gli",
       "ha",
       "hai",
       "hanno",
       "ho",
       "i",
       "il",
       "in",
       "io",
       "l",
       "la",
       "le",
       "lei",
       "li",
       "lo",
       "loro",
       "lui",
       "ma",
       "me",
       "mi",
       "mia",
       "mie",
       "miei",
       "mio",
       "ne",
       "negl",
       "negli",
       "nei",
       "nel",
       "nell",
       "nella",
       "nelle",
       "nello",
       "no",
       "noi",
       "non",
       "nostra",
       "nostre",
       "nostri",
       "nostro",
       "o",
       "per",
       "perché",
       "però",
       "più",
       "pochi",
       "poco",
       "qua",
       "quale",
       "quanta",
       "quante",
       "quanti",
       "quanto",
       "quasi",
       "quella",
       "quelle",
       "quelli",
       "quello",
       "questa",
       "queste",
       "questi",
       "questo",
       "qui",
       "quindi",
       "sarai",
       "saranno",
       "sarebbe",
       "sarebbero",
       "sarei",
       "saremmo",
       "saremo",
       "sareste",
       "saresti",
       "sarete",
       "sarà",
       "sarò",
       "se",
       "sei",
       "senza",
       "si",
       "sia",
       "siamo",
       "siano",
       "siate",
       "siete",
       "sono",
       "sopra",
       "sotto",
       "sta",
       "stai",
       "stando",
       "stanno",
       "starai",
       "staranno",
       "stare",
       "starebbe",
       "starebbero",
       "starei",
       "staremmo",
       "staremo",
       "stareste",
       "staresti",
       "starete",
       "starà",
       "starò",
       "stava",
       "stavamo",
       "stavano",
       "stavate",
       "stavi",
       "stavo",
       "stemmo",
       "stesse",
       "stessero",
       "stessi",
       "stessimo",
       "stesso",
       "steste",
       "stesti",
       "stette",
       "stettero",
       "stetti",
       "stia",
       "stiamo",
       "stiano",
       "stiate",
       "sto",
       "su",
       "sua",
       "sue",
       "sugl",
       "sugli",
       "sui",
       "sul",
       "sull",
       "sulla",
       "sulle",
       "sullo",
       "suo",
       "suoi",
       "te",
       "ti",
       "tra",
       "tu",
       "tua",
       "tue",
       "tuo",
       "tuoi",
       "tutti",
       "tutto",
       "un",
       "una",
       "uno",
       "vai",
       "vi",
       "voi",
       "vostra",
       "vostre",
       "vostri",
       "vostro",
       "è",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["italian"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_norwegian.txt
  {
   const char* const words[] = {
       "alle",
       "at",
       "av",
       "bare",
       "begge",
       "ble",
       "blei",
       "bli",
       "blir",
       "blitt",
       "både",
       "båe",
       "da",
       "de",
       "deg",
       "dei",
       "deim",
       "deira",
       "deires",
       "dem",
       "den",
       "denne",
       "der",
       "dere",
       "deres",
       "det",
       "dette",
       "di",
       "din",
       "disse",
       "ditt",
       "du",
       "dykk",
       "dykkar",
       "då",
       "eg",
       "ein",
       "eit",
       "eitt",
       "eller",
       "elles",
       "en",
       "enn",
       "er",
       "et",
       "ett",
       "etter",
       "for",
       "fordi",
       "fra",
       "før",
       "ha",
       "hadde",
       "han",
       "hans",
       "har",
       "hennar",
       "henne",
       "hennes",
       "her",
       "hjå",
       "ho",
       "hoe",
       "honom",
       "hoss",
       "hossen",
       "hun",
       "hva",
       "hvem",
       "hver",
       "hvilke",
       "hvilken",
       "hvis",
       "hvor",
       "hvordan",
       "hvorfor",
       "i",
       "ikke",
       "ikkje",
       "ingen",
       "ingi",
       "inkje",
       "inn",
       "inni",
       "ja",
       "jeg",
       "kan",
       "kom",
       "korleis",
       "korso",
       "kun",
       "kunne",
       "kva",
       "kvar",
       "kvarhelst",
       "kven",
       "kvi",
       "kvifor",
       "man",
       "mange",
       "me",
       "med",
       "medan",
       "meg",
       "meget",
       "mellom",
       "men",
       "mi",
       "min",
       "mine",
       "mitt",
       "mot",
       "mykje",
       "ned",
       "no",
       "noe",
       "noen",
       "noka",
       "noko",
       "nokon",
       "nokor",
       "nokre",
       "nå",
       "når",
       "og",
       "også",
       "om",
       "opp",
       "oss",
       "over",
       "på",
       "samme",
       "seg",
       "selv",
       "si",
       "sia",
       "sidan",
       "siden",
       "sin",
       "sine",
       "sitt",
       "sjøl",
       "skal",
       "skulle",
       "slik",
       "so",
       "som",
       "somme",
       "somt",
       "så",
       "sånn",
       "til",
       "um",
       "upp",
       "ut",
       "uten",
       "var",
       "vart",
       "varte",
       "ved",
       "vere",
       "verte",
       "vi",
       "vil",
       "ville",
       "vore",
       "vors",
       "vort",
       "være",
       "vært",
       "vår",
       "å",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["norwegian"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_portuguese.txt
  {
   const char* const words[] = {
       "a",
       "ao",
       "aos",
       "aquela",
       "aquelas",
       "aquele",
       "aqueles",
       "aquilo",
       "as",
       "até",
       "com",
       "como",
       "da",
       "das",
       "de",
       "dela",
       "delas",
       "dele",
       "deles",
       "depois",
       "do",
       "dos",
       "e",
       "ela",
       "elas",
       "ele",
       "eles",
       "em",
       "entre",
       "era",
       "eram",
       "essa",
       "essas",
       "esse",
       "esses",
       "esta",
       "estamos",
       "estas",
       "estava",
       "estavam",
       "este",
       "esteja",
       "estejam",
       "estejamos",
       "estes",
       "esteve",
       "estive",
       "estivemos",
       "estiver",
       "estivera",
       "estiveram",
       "estiverem",
       "estivermos",
       "estivesse",
       "estivessem",
       "estivéramos",
       "estivéssemos",
       "estou",
       "está",
       "estávamos",
       "estão",
       "eu",
       "foi",
       "fomos",
       "for",
       "fora",
       "foram",
       "forem",
       "formos",
       "fosse",
       "fossem",
       "fui",
       "fôramos",
       "fôssemos",
       "haja",
       "hajam",
       "hajamos",
       "havemos",
       "hei",
       "houve",
       "houvemos",
       "houver",
       "houvera",
       "houveram",
       "houverei",
       "houverem",
       "houveremos",
       "houveria",
       "houveriam",
       "houvermos",
       "houverá",
       "houverão",
       "houveríamos",
       "houvesse",
       "houvessem",
       "houvéramos",
       "houvéssemos",
       "há",
       "hão",
       "isso",
       "isto",
       "já",
       "lhe",
       "lhes",
       "mais",
       "mas",
       "me",
       "mesmo",
       "meu",
       "meus",
       "minha",
       "minhas",
       "muito",
       "na",
       "nas",
       "nem",
       "no",
       "nos",
       "nossa",
       "nossas",
       "nosso",
       "nossos",
       "num",
       "numa",
       "não",
       "nós",
       "o",
       "os",
       "ou",
       "para",
       "pela",
       "pelas",
       "pelo",
       "pelos",
       "por",
       "qual",
       "quando",
       "que",
       "quem",
       "se",
       "seja",
       "sejam",
       "sejamos",
       "sem",
       "serei",
       "seremos",
       "seria",
       "seriam",
       "será",
       "serão",
       "seríamos",
       "seu",
       "seus",
       "somos",
       "sou",
       "sua",
       "suas",
       "são",
       "só",
       "também",
       "te",
       "tem",
       "temos",
       "tenha",
       "tenham",
       "tenhamos",
       "tenho",
       "terei",
       "teremos",
       "teria",
       "teriam",
       "terá",
       "terão",
       "teríamos",
       "teu",
       "teus",
       "teve",
       "tinha",
       "tinham",
       "tive",
       "tivemos",
       "tiver",
       "tivera",
       "tiveram",
       "tiverem",
       "tivermos",
       "tivesse",
       "tivessem",
       "tivéramos",
       "tivéssemos",
       "tu",
       "tua",
       "tuas",
       "tém",
       "tínhamos",
       "um",
       "uma",
       "você",
       "vocês",
       "vos",
       "à",
       "às",
       "éramos",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["portuguese"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_romanian.txt
  {
   const char* const words[] = {
       "vreo",
       "acelea",
       "cita",
       "degraba",
       "lor",
       "alta",
       "tot",
       "ai",
       "dat",
       "x",
       "despre",
       "peste",
       "bine",
       "dar",
       "foarte",
       "z",
       "avea",
       "multi",
       "cit",
       "alt",
       "mai",
       "sa",
       "fie",
       "tu",
       "multe",
       "e",
       "orice",
       "dintr",
       "se",
       "g",
       "intr",
       "niste",
       "multa",
       "insa",
       "il",
       "fost",
       "a",
       "abia",
       "nimic",
       "sub",
       "acel",
       "in",
       "altceva",
       "si",
       "avem",
       "altfel",
       "c",
       "ea",
       "acest",
       "li",
       "parca",
       "fi",
       "dintre",
       "unele",
       "m",
       "acestei",
       "mare",
       "cel",
       "este",
       "pe",
       "atitia",
       "uneori",
       "acela",
       "iti",
       "astazi",
       "acestui",
       "o",
       "imi",
       "ele",
       "ceilalti",
       "pai",
       "fata",
       "noua",
       "sa-ti",
       "altul",
       "au",
       "i",
       "prin",
       "conform",
       "aceste",
       "anume",
       "azi",
       "k",
       "unul",
       "ala",
       "unei",
       "fara",
       "ei",
       "la",
       "aceeasi",
       "u",
       "inapoi",
       "acestea",
       "acesta",
       "catre",
       "sale",
       "asupra",
       "as",
       "aceea",
       "ba",
       "ale",
       "da",
       "le",
       "apoi",
       "aia",
       "suntem",
       "cum",
       "isi",
       "inainte",
       "s",
       "de",
       "cind",
       "cumva",
       "chiar",
       "acestia",
       "daca",
       "sunt",
       "care",
       "al",
       "numai",
       "cui",
       "sus",
       "tocmai",
       "prea",
       "cu",
       "mi",
       "eu",
       "doar",
       "niciodata",
       "exact",
       "putini",
       "aiurea",
       "tuturor",
       "celor",
       "astfel",
       "atunci",
       "citeva",
       "cat",
       "sau",
       "fel",
       "intre",
       "acolo",
       "nostri",
       "ma",
       "mult",
       "una",
       "ceea",
       "iar",
       "sintem",
       "ati",
       "din",
       "geaba",
       "sai",
       "caruia",
       "adica",
       "inca",
       "are",
       "aici",
       "ca",
       "ia",
       "nici",
       "d",
       "oricum",
       "asta",
       "carora",
       "face",
       "citiva",
       "voi",
       "unor",
       "f",
       "atat",
       "toata",
       "alaturi",
       "cea",
       "nu",
       "totusi",
       "ce",
       "altii",
       "acum",
       "sint",
       "capat",
       "mod",
       "deasupra",
       "cam",
       "vom",
       "b",
       "toate",
       "careia",
       "aceasta",
       "atit",
       "nimeni",
       "ii",
       "ci",
       "unde",
       "ul",
       "plus",
       "era",
       "sa-mi",
       "l",
       "spre",
       "dupa",
       "nou",
       "cele",
       "acea",
       "un",
       "incit",
       "n",
       "cei",
       "or",
       "va",
       "deci",
       "acelasi",
       "atatea",
       "h",
       "vor",
       "decit",
       "noi",
       "cineva",
       "desi",
       "ceva",
       "j",
       "ului",
       "atitea",
       "avut",
       "ar",
       "pina",
       "t",
       "atata",
       "unui",
       "el",
       "citi",
       "asa",
       "totul",
       "pentru",
       "atita",
       "v",
       "alti",
       "asemenea",
       "atatia",
       "te",
       "ne",
       "deja",
       "unii",
       "p",
       "atare",
       "cite",
       "cine",
       "cand",
       "toti",
       "vreun",
       "ori",
       "r",
       "alte",
       "lui",
       "ti",
       "ni",
       "aceia",
       "am",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["romanian"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_russian.txt
  {
   const char* const words[] = {
       "а",
       "без",
       "более",
       "больше",
       "будет",
       "будто",
       "бы",
       "был",
       "была",
       "были",
       "было",
       "быть",
       "в",
       "вам",
       "вас",
       "вдруг",
       "ведь",
       "во",
       "вот",
       "вроем",
       "все",
       "всегда",
       "всего",
       "всех",
       "всю",
       "вы",
       "где",
       "говорил",
       "да",
       "даже",
       "два",
       "для",
       "до",
       "другой",
       "его",
       "его",
       "ее",
       "ее",
       "ей",
       "еловек",
       "ем",
       "ему",
       "еред",
       "ерез",
       "если",
       "есть",
       "ж",
       "же",
       "жизнь",
       "за",
       "заем",
       "здесь",
       "и",
       "из",
       "или",
       "им",
       "иногда",
       "их",
       "к",
       "кажется",
       "как",
       "какая",
       "какой",
       "когда",
       "конено",
       "кто",
       "куда",
       "ли",
       "луше",
       "между",
       "меня",
       "мне",
       "много",
       "может",
       "можно",
       "мой",
       "моя",
       "мы",
       "на",
       "над",
       "надо",
       "наконец",
       "нас",
       "не",
       "него",
       "нее",
       "ней",
       "нельзя",
       "нет",
       "ни",
       "нибудь",
       "ниего",
       "никогда",
       "ним",
       "них",
       "но",
       "ну",
       "о",
       "о",
       "об",
       "од",
       "один",
       "он",
       "она",
       "они",
       "осле",
       "от",
       "оти",
       "отом",
       "отому",
       "оять",
       "раз",
       "разве",
       "ри",
       "ро",
       "с",
       "сам",
       "свою",
       "себе",
       "себя",
       "сегодня",
       "сейас",
       "сказал",
       "сказала",
       "сказать",
       "со",
       "совсем",
       "так",
       "такой",
       "там",
       "тебя",
       "теерь",
       "тем",
       "то",
       "то",
       "тоб",
       "тобы",
       "тогда",
       "того",
       "тоже",
       "только",
       "том",
       "тот",
       "три",
       "тут",
       "ты",
       "у",
       "уж",
       "уже",
       "уть",
       "хорошо",
       "хоть",
       "эти",
       "этого",
       "этой",
       "этом",
       "этот",
       "эту",
       "я",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["russian"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_spanish.txt
  {
   const char* const words[] = {
       "a",
       "al",
       "algo",
       "algunas",
       "algunos",
       "ante",
       "antes",
       "como",
       "con",
       "contra",
       "cual",
       "cuando",
       "de",
       "del",
       "desde",
       "donde",
       "durante",
       "e",
       "el",
       "ella",
       "ellas",
       "ellos",
       "en",
       "entre",
       "era",
       "erais",
       "eran",
       "eras",
       "eres",
       "es",
       "esa",
       "esas",
       "ese",
       "eso",
       "esos",
       "esta",
       "estaba",
       "estabais",
       "estaban",
       "estabas",
       "estad",
       "estada",
       "estadas",
       "estado",
       "estados",
       "estamos",
       "estando",
       "estar",
       "estaremos",
       "estará",
       "estarán",
       "estarás",
       "estaré",
       "estaréis",
       "estaría",
       "estaríais",
       "estaríamos",
       "estarían",
       "estarías",
       "estas",
       "este",
       "estemos",
       "esto",
       "estos",
       "estoy",
       "estuve",
       "estuviera",
       "estuvierais",
       "estuvieran",
       "estuvieras",
       "estuvieron",
       "estuviese",
       "estuvieseis",
       "estuviesen",
       "estuvieses",
       "estuvimos",
       "estuviste",
       "estuvisteis",
       "estuviéramos",
       "estuviésemos",
       "estuvo",
       "está",
       "estábamos",
       "estáis",
       "están",
       "estás",
       "esté",
       "estéis",
       "estén",
       "estés",
       "fue",
       "fuera",
       "fuerais",
       "fueran",
       "fueras",
       "fueron",
       "fuese",
       "fueseis",
       "fuesen",
       "fueses",
       "fui",
       "fuimos",
       "fuiste",
       "fuisteis",
       "fuéramos",
       "fuésemos",
       "ha",
       "habida",
       "habidas",
       "habido",
       "habidos",
       "habiendo",
       "habremos",
       "habrá",
       "habrán",
       "habrás",
       "habré",
       "habréis",
       "habría",
       "habríais",
       "habríamos",
       "habrían",
       "habrías",
       "habéis",
       "había",
       "habíais",
       "habíamos",
       "habían",
       "habías",
       "han",
       "has",
       "hasta",
       "hay",
       "haya",
       "hayamos",
       "hayan",
       "hayas",
       "hayáis",
       "he",
       "hemos",
       "hube",
       "hubiera",
       "hubierais",
       "hubieran",
       "hubieras",
       "hubieron",
       "hubiese",
       "hubieseis",
       "hubiesen",
       "hubieses",
       "hubimos",
       "hubiste",
       "hubisteis",
       "hubiéramos",
       "hubiésemos",
       "hubo",
       "la",
       "las",
       "le",
       "les",
       "lo",
       "los",
       "me",
       "mi",
       "mis",
       "mucho",
       "muchos",
       "muy",
       "más",
       "mí",
       "mía",
       "mías",
       "mío",
       "míos",
       "nada",
       "ni",
       "no",
       "nos",
       "nosotras",
       "nosotros",
       "nuestra",
       "nuestras",
       "nuestro",
       "nuestros",
       "o",
       "os",
       "otra",
       "otras",
       "otro",
       "otros",
       "para",
       "pero",
       "poco",
       "por",
       "porque",
       "que",
       "quien",
       "quienes",
       "qué",
       "se",
       "sea",
       "seamos",
       "sean",
       "seas",
       "seremos",
       "será",
       "serán",
       "serás",
       "seré",
       "seréis",
       "sería",
       "seríais",
       "seríamos",
       "serían",
       "serías",
       "seáis",
       "sido",
       "siendo",
       "sin",
       "sobre",
       "sois",
       "somos",
       "son",
       "soy",
       "su",
       "sus",
       "suya",
       "suyas",
       "suyo",
       "suyos",
       "sí",
       "también",
       "tanto",
       "te",
       "tendremos",
       "tendrá",
       "tendrán",
       "tendrás",
       "tendré",
       "tendréis",
       "tendría",
       "tendríais",
       "tendríamos",
       "tendrían",
       "tendrías",
       "tened",
       "tenemos",
       "tenga",
       "tengamos",
       "tengan",
       "tengas",
       "tengo",
       "tengáis",
       "tenida",
       "tenidas",
       "tenido",
       "tenidos",
       "teniendo",
       "tenéis",
       "tenía",
       "teníais",
       "teníamos",
       "tenían",
       "tenías",
       "ti",
       "tiene",
       "tienen",
       "tienes",
       "todo",
       "todos",
       "tu",
       "tus",
       "tuve",
       "tuviera",
       "tuvierais",
       "tuvieran",
       "tuvieras",
       "tuvieron",
       "tuviese",
       "tuvieseis",
       "tuviesen",
       "tuvieses",
       "tuvimos",
       "tuviste",
       "tuvisteis",
       "tuviéramos",
       "tuviésemos",
       "tuvo",
       "tuya",
       "tuyas",
       "tuyo",
       "tuyos",
       "tú",
       "un",
       "una",
       "uno",
       "unos",
       "vosotras",
       "vosotros",
       "vuestra",
       "vuestras",
       "vuestro",
       "vuestros",
       "y",
       "ya",
       "yo",
       "él",
       "éramos",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["spanish"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_swedish.txt
  {
   const char* const words[] = {
       "alla",
       "allt",
       "att",
       "av",
       "blev",
       "bli",
       "blir",
       "blivit",
       "de",
       "dem",
       "den",
       "denna",
       "deras",
       "dess",
       "dessa",
       "det",
       "detta",
       "dig",
       "din",
       "dina",
       "ditt",
       "du",
       "där",
       "då",
       "efter",
       "ej",
       "eller",
       "en",
       "er",
       "era",
       "ert",
       "ett",
       "från",
       "för",
       "ha",
       "hade",
       "han",
       "hans",
       "har",
       "henne",
       "hennes",
       "hon",
       "honom",
       "hur",
       "här",
       "i",
       "icke",
       "ingen",
       "inom",
       "inte",
       "jag",
       "ju",
       "kan",
       "kunde",
       "man",
       "med",
       "mellan",
       "men",
       "mig",
       "min",
       "mina",
       "mitt",
       "mot",
       "mycket",
       "ni",
       "nu",
       "när",
       "någon",
       "något",
       "några",
       "och",
       "om",
       "oss",
       "på",
       "samma",
       "sedan",
       "sig",
       "sin",
       "sina",
       "sitta",
       "själv",
       "skulle",
       "som",
       "så",
       "sådan",
       "sådana",
       "sådant",
       "till",
       "under",
       "upp",
       "ut",
       "utan",
       "vad",
       "var",
       "vara",
       "varför",
       "varit",
       "varje",
       "vars",
       "vart",
       "vem",
       "vi",
       "vid",
       "vilka",
       "vilkas",
       "vilken",
       "vilket",
       "vår",
       "våra",
       "vårt",
       "än",
       "är",
       "åt",
       "över",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["swedish"];
   l.insert(&words[0], &words[wordcnt]);
  }
  // src/mongo/db/fts/stop_words_turkish.txt
  {
   const char* const words[] = {
       "mu",
       "onlar",
       "seksen",
       "ama",
       "trilyon",
       "buna",
       "bizim",
       "þeyden",
       "yirmi",
       "altý",
       "iki",
       "seni",
       "doksan",
       "dört",
       "bunun",
       "ki",
       "nereye",
       "altmýþ",
       "hem",
       "milyon",
       "kez",
       "otuz",
       "beþ",
       "elli",
       "bizi",
       "da",
       "sekiz",
       "ve",
       "çok",
       "bu",
       "veya",
       "ya",
       "kýrk",
       "onlarýn",
       "ona",
       "bana",
       "yetmiþ",
       "milyar",
       "þunu",
       "senden",
       "birþeyi",
       "dokuz",
       "yani",
       "kimi",
       "þeyler",
       "kim",
       "neden",
       "senin",
       "yedi",
       "niye",
       "üç",
       "þey",
       "mý",
       "tüm",
       "onlari",
       "bunda",
       "ise",
       "þundan",
       "hep",
       "þuna",
       "bin",
       "ben",
       "ondan",
       "kimden",
       "bazý",
       "belki",
       "ne",
       "bundan",
       "gibi",
       "de",
       "onlardan",
       "sizi",
       "sizin",
       "daha",
       "niçin",
       "þunda",
       "bunu",
       "beni",
       "ile",
       "þu",
       "þeyi",
       "sizden",
       "defa",
       "biz",
       "için",
       "dahi",
       "siz",
       "nerde",
       "kime",
       "birþey",
       "birkez",
       "her",
       "biri",
       "on",
       "mü",
       "diye",
       "acaba",
       "sen",
       "en",
       "hepsi",
       "bir",
       "bizden",
       "sanki",
       "benim",
       "nerede",
       "onu",
       "benden",
       "yüz",
       "birkaç",
       "çünkü",
       "nasýl",
       "hiç",
       "katrilyon",
   };
   const size_t wordcnt = sizeof(words) / sizeof(words[0]);
   std::set< std::string >& l = (*m)["turkish"];
   l.insert(&words[0], &words[wordcnt]);
  }

  }
} // namespace fts
} // namespace mongo
